//================================================================================
// MapVoteClientWindow.
//================================================================================
class MapVoteClientWindow extends UWindowPageWindow;

var MapvoteListBox MapListBox[4];
var UWindowSmallButton CloseButton;
var UWindowSmallButton VoteButton;
var UWindowSmallButton InfoButton;
var PlayerVoteListBox PlayerListBox;
var UWindowSmallButton KickVoteButton;
var MapStatusListBox lstMapStatus;
var KickStatusListBox lstKickStatus;
var UWindowCheckbox cbLoadScreenShot;
var UMenuLabelControl lblStatusTitles;
var UMenuLabelControl lblTitle1;
var UMenuLabelControl lblTitle2;
var UMenuLabelControl lblTitle3;
var UMenuLabelControl lblTitle4;
var UMenuLabelControl lblTitle;
var UMenuLabelControl lblMaptxt1;
var UMenuLabelControl lblMaptxt2;
var UMenuLabelControl lblMaptxt3;
var UMenuLabelControl lblPriority1;
var UMenuLabelControl lblPriority2;
var UMenuLabelControl lblPriority3;
var UMenuLabelControl lblPriority4;
var UMenuLabelControl lblMapCount;
var UWindowEditControl txtFind;
var UWindowSmallButton SendButton;
var UWindowEditControl txtMessage;
var UMenuLabelControl lblMode;
var bool bKickVote;
var Texture Screenshot;
var string MapTitle;
var string MapAuthor;
var string IdealPlayerCount;
var float LastVoteTime;
var float SelectionTime;
var string LogoTexture;
var int MapListwidth;
var int PlayerListwidth;
var int ListHeight;
var bool bMapAlreadySet;
var string PrefixDictionary;
var Color RedColor;
var Color PurpleColor;
var Color LightBlueColor;
var Color TurquoiseColor;
var Color GreenColor;
var Color OrangeColor;
var Color YellowColor;
var Color PinkColor;
var Color WhiteColor;
var Color DeepBlueColor;
var Color BlackColor;
var UWindowEditControl txtSearch;
var UWindowSmallButton btnNext, btnPrev;
var int SelectedSearchIndex;
var UMenuLabelControl lbSearchStatus;
var float SearchOffset;
var int TotalSearchItems;
var string CurrentMapName;

struct ST_MapvoteList
{
  var UMenuMapvoteList Item;
  var byte Column;
};

var ST_MapvoteList SearchList[4096];

function Created ()
{
  local Color TextColor;
  local Color MainTitleColor;
  local Color TitleColor;
  local Color List1TitleColor;
  local Color List2TitleColor;
  local Color List3TitleColor;
  local Color List4TitleColor;
  local Color TitleColor1;
  local Color TitleColor2;
  local Color TitleColor3;
  local Color TitleColor4;
  local Color TextColorTitles;
  local Color TextColorTitle;
  local int LowSectionStart;
	local int RightSectionStart, XL;

	Super.Created();

	if(Class'MVULClientSettings'.default.MainTitleColor == 0)
		TitleColor = RedColor;
	else if(Class'MVULClientSettings'.default.MainTitleColor == 1)
		TitleColor = PurpleColor;
	else if(Class'MVULClientSettings'.default.MainTitleColor == 2)
		TitleColor = LightBlueColor;
	else if(Class'MVULClientSettings'.default.MainTitleColor == 3)
		TitleColor = TurquoiseColor;
	else if(Class'MVULClientSettings'.default.MainTitleColor == 4)
		TitleColor = GreenColor;
	else if(Class'MVULClientSettings'.default.MainTitleColor == 5)
		TitleColor = OrangeColor;
	else if(Class'MVULClientSettings'.default.MainTitleColor == 6)
		TitleColor = YellowColor;
	else if(Class'MVULClientSettings'.default.MainTitleColor == 7)
		TitleColor = PinkColor;
	else if(Class'MVULClientSettings'.default.MainTitleColor == 8)
		TitleColor = WhiteColor;
	else if(Class'MVULClientSettings'.default.MainTitleColor == 9)
		TitleColor = DeepBlueColor;
	else if(Class'MVULClientSettings'.default.MainTitleColor == 10)
		TitleColor = BlackColor;

	if(Class'MVULClientSettings'.default.List1TitleColor == 0)
		TitleColor1 = RedColor;
	else if(Class'MVULClientSettings'.default.List1TitleColor == 1)
		TitleColor1 = PurpleColor;
	else if(Class'MVULClientSettings'.default.List1TitleColor == 2)
		TitleColor1 = LightBlueColor;
	else if(Class'MVULClientSettings'.default.List1TitleColor == 3)
		TitleColor1 = TurquoiseColor;
	else if(Class'MVULClientSettings'.default.List1TitleColor == 4)
		TitleColor1 = GreenColor;
	else if(Class'MVULClientSettings'.default.List1TitleColor == 5)
		TitleColor1 = OrangeColor;
	else if(Class'MVULClientSettings'.default.List1TitleColor == 6)
		TitleColor1 = YellowColor;
	else if(Class'MVULClientSettings'.default.List1TitleColor == 7)
		TitleColor1 = PinkColor;
	else if(Class'MVULClientSettings'.default.List1TitleColor == 8)
		TitleColor1 = WhiteColor;
	else if(Class'MVULClientSettings'.default.List1TitleColor == 9)
		TitleColor1 = DeepBlueColor;
	else if(Class'MVULClientSettings'.default.List1TitleColor == 10)
		TitleColor1 = BlackColor;

	if(Class'MVULClientSettings'.default.List2TitleColor == 0)
		TitleColor2 = RedColor;
	else if(Class'MVULClientSettings'.default.List2TitleColor == 1)
		TitleColor2 = PurpleColor;
	else if(Class'MVULClientSettings'.default.List2TitleColor == 2)
		TitleColor2 = LightBlueColor;
	else if(Class'MVULClientSettings'.default.List2TitleColor == 3)
		TitleColor2 = TurquoiseColor;
	else if(Class'MVULClientSettings'.default.List2TitleColor == 4)
		TitleColor2 = GreenColor;
	else if(Class'MVULClientSettings'.default.List2TitleColor == 5)
		TitleColor2 = OrangeColor;
	else if(Class'MVULClientSettings'.default.List2TitleColor == 6)
		TitleColor2 = YellowColor;
	else if(Class'MVULClientSettings'.default.List2TitleColor == 7)
		TitleColor2 = PinkColor;
	else if(Class'MVULClientSettings'.default.List2TitleColor == 8)
		TitleColor2 = WhiteColor;
	else if(Class'MVULClientSettings'.default.List2TitleColor == 9)
		TitleColor2 = DeepBlueColor;
	else if(Class'MVULClientSettings'.default.List2TitleColor == 10)
		TitleColor2 = BlackColor;

	if(Class'MVULClientSettings'.default.List3TitleColor == 0)
		TitleColor3 = RedColor;
	else if(Class'MVULClientSettings'.default.List3TitleColor == 1)
		TitleColor3 = PurpleColor;
	else if(Class'MVULClientSettings'.default.List3TitleColor == 2)
		TitleColor3 = LightBlueColor;
	else if(Class'MVULClientSettings'.default.List3TitleColor == 3)
		TitleColor3 = TurquoiseColor;
	else if(Class'MVULClientSettings'.default.List3TitleColor == 4)
		TitleColor3 = GreenColor;
	else if(Class'MVULClientSettings'.default.List3TitleColor == 5)
		TitleColor3 = OrangeColor;
	else if(Class'MVULClientSettings'.default.List3TitleColor == 6)
		TitleColor3 = YellowColor;
	else if(Class'MVULClientSettings'.default.List3TitleColor == 7)
		TitleColor3 = PinkColor;
	else if(Class'MVULClientSettings'.default.List3TitleColor == 8)
		TitleColor3 = WhiteColor;
	else if(Class'MVULClientSettings'.default.List3TitleColor == 9)
		TitleColor3 = DeepBlueColor;
	else if(Class'MVULClientSettings'.default.List3TitleColor == 10)
		TitleColor3 = BlackColor;

	if(Class'MVULClientSettings'.default.List4TitleColor == 0)
		TitleColor4 = RedColor;
	else if(Class'MVULClientSettings'.default.List4TitleColor == 1)
		TitleColor4 = PurpleColor;
	else if(Class'MVULClientSettings'.default.List4TitleColor == 2)
		TitleColor4 = LightBlueColor;
	else if(Class'MVULClientSettings'.default.List4TitleColor == 3)
		TitleColor4 = TurquoiseColor;
	else if(Class'MVULClientSettings'.default.List4TitleColor == 4)
		TitleColor4 = GreenColor;
	else if(Class'MVULClientSettings'.default.List4TitleColor == 5)
		TitleColor4 = OrangeColor;
	else if(Class'MVULClientSettings'.default.List4TitleColor == 6)
		TitleColor4 = YellowColor;
	else if(Class'MVULClientSettings'.default.List4TitleColor == 7)
		TitleColor4 = PinkColor;
	else if(Class'MVULClientSettings'.default.List4TitleColor == 8)
		TitleColor4 = WhiteColor;
	else if(Class'MVULClientSettings'.default.List4TitleColor == 9)
		TitleColor4 = DeepBlueColor;
	else if(Class'MVULClientSettings'.default.List4TitleColor == 10)
		TitleColor4 = BlackColor;

	TextColor.R=171;
	TextColor.G=171;
	TextColor.B=171;
	TextColorTitles.R=255;
	TextColorTitles.G=10;
	TextColorTitles.B=10;
	TextColorTitle.R=255;
	TextColorTitle.G=255;
	TextColorTitle.B=10;

	MapListwidth=120;
	PlayerListwidth=120;
	ListHeight=324;
  LowSectionStart = ListHeight + 81;
  RightSectionStart = 400;

	MapListBox[0]=MapVoteListBox(CreateControl(Class'MapVoteListBox',10.00,26.00,MapListwidth,ListHeight));
	MapListBox[0].Items.Clear();
	MapListBox[1]=MapVoteListBox(CreateControl(Class'MapVoteListBox',20.00 + MapListwidth,26.00,MapListwidth,ListHeight));
	MapListBox[1].Items.Clear();
	MapListBox[2]=MapVoteListBox(CreateControl(Class'MapVoteListBox',40.00 + 2 * MapListwidth + PlayerListwidth,26.00,MapListwidth,ListHeight));
	MapListBox[2].Items.Clear();
	MapListBox[3]=MapVoteListBox(CreateControl(Class'MapVoteListBox',50.00 + 3 * MapListwidth + PlayerListwidth,26.00,MapListwidth,ListHeight));
	MapListBox[3].Items.Clear();

	VoteButton = UWindowSmallButton(CreateControl(Class'UWindowSmallButton',10.0,ListHeight + 46,40.0 + 4 * MapListwidth + PlayerListwidth,21.0));
	VoteButton.DownSound=Sound'Botpack.Click';
	VoteButton.Text="Vote";
	VoteButton.bDisabled=False;

	PlayerListBox = PlayerVoteListBox(CreateControl(Class'PlayerVoteListBox',30.0 + 2 * MapListwidth,172.0,PlayerListwidth,-188.0 + ListHeight));
	PlayerListBox.Items.Clear();
	PlayerListBox.bDisabled=True;

	KickVoteButton = UWindowSmallButton(CreateControl(Class'UWindowSmallButton',30.0 + 2 * MapListwidth,ListHeight - 11,PlayerListwidth,18.0));
	KickVoteButton.DownSound=Sound'Botpack.Click';
	if ( bKickVote || GetPlayerOwner().PlayerReplicationInfo.bAdmin )
	{
		KickVoteButton.Text="Kick";
		KickVoteButton.bDisabled=True;
	} else {
		KickVoteButton.Text="";
		KickVoteButton.bDisabled=False;
	}
	lblStatusTitles = UMenuLabelControl(CreateControl(Class'UMenuLabelControl',10.0,LowSectionStart - 15,30.0 + 2 * MapListwidth + PlayerListwidth,10.0));
	lblStatusTitles.SetText("Rank   Map name                       Votes                          Player name    Votes");
	lblStatusTitles.SetFont(0);
	lblStatusTitles.SetTextColor(TextColor);

	lstMapStatus=MapStatusListBox(CreateControl(Class'MapStatusListBox',10.00,LowSectionStart,200.00,90.00));
	lstMapStatus.bAcceptsFocus=False;
	lstMapStatus.Items.Clear();

	lstKickStatus=KickStatusListBox(CreateControl(Class'KickStatusListBox',230.00,LowSectionStart,150.00,90.00));
	lstKickStatus.bAcceptsFocus=False;
	lstKickStatus.Items.Clear();

	lblMaptxt1=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',30.00 + 2 * MapListwidth,140.00,PlayerListwidth,10.00));
	lblMaptxt1.SetTextColor(TextColor);
	lblMaptxt1.Align=TA_Center;

	lblMaptxt2=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',30.00 + 2 * MapListwidth,149.00,PlayerListwidth,10.00));
	lblMaptxt2.SetTextColor(TextColor);
	lblMaptxt2.Align=TA_Center;

	lblMaptxt3=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',30.00 + 2 * MapListwidth,158.00,PlayerListwidth,10.00));
	lblMaptxt3.SetTextColor(TextColor);
	lblMaptxt3.Align=TA_Center;

	lblTitle1=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',0.00,10.00,MapListwidth + 20,20.00));
	lblTitle1.SetFont(1);
	lblTitle1.Align=TA_Center;
	lblTitle1.SetTextColor(TitleColor1);

	lblTitle2=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',10.00 + MapListwidth,10.00,MapListwidth + 20,20.00));
	lblTitle2.SetFont(1);
	lblTitle2.Align=TA_Center;
	lblTitle2.SetTextColor(TitleColor2);

	lblTitle=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',15.00 + 2 * MapListwidth,10.00,PlayerListwidth + 30,20.00));
	lblTitle.SetFont(1);
	lblTitle.Align=TA_Center;
	lblTitle.SetTextColor(TitleColor);

	lblTitle3=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',30.00 + 2 * MapListwidth + PlayerListwidth,10.00,MapListwidth + 20,20.00));
	lblTitle3.SetFont(1);
	lblTitle3.Align=TA_Center;
	lblTitle3.SetTextColor(TitleColor3);

	lblTitle4=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',40.00 + 3 * MapListwidth + PlayerListwidth,10.00,MapListwidth + 20,20.00));
	lblTitle4.SetFont(1);
	lblTitle4.Align=TA_Center;
	lblTitle4.SetTextColor(TitleColor4);

	lblPriority1=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',0.00,ListHeight + 30,MapListwidth + 20,20.00));
	lblPriority1.Align=TA_Center;
	lblPriority1.SetTextColor(TextColor);

	lblPriority2=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',10.00 + MapListwidth,ListHeight + 30,MapListwidth + 20,20.00));
	lblPriority2.Align=TA_Center;
	lblPriority2.SetTextColor(TextColor);

	lblPriority3=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',30.00 + 2 * MapListwidth + PlayerListwidth,ListHeight + 30,MapListwidth + 20,20.00));
	lblPriority3.Align=TA_Center;
	lblPriority3.SetTextColor(TextColor);

	lblPriority4=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',40.00 + 3 * MapListwidth + PlayerListwidth,ListHeight + 30,MapListwidth + 20,20.00));
	lblPriority4.Align=TA_Center;
	lblPriority4.SetTextColor(TextColor);

	lblMapCount=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',RightSectionStart,LowSectionStart,110.00,20.00));
	lblMapCount.SetFont(0);
	lblMapCount.SetTextColor(TextColor);
	lblMode=UMenuLabelControl(CreateControl(Class'UMenuLabelControl',RightSectionStart + 120,LowSectionStart,100.00,20.00));
	lblMode.SetText("Mode:");
	lblMode.SetFont(0);
	lblMode.SetTextColor(TextColor);
	cbLoadScreenShot=UWindowCheckbox(CreateControl(Class'UWindowCheckbox',RightSectionStart,LowSectionStart + 20,70.00,20.00));
	cbLoadScreenShot.SetText("ScreenShot");
	cbLoadScreenShot.Align=TA_Right;
	cbLoadScreenShot.SetFont(0);
	cbLoadScreenShot.SetTextColor(TextColor);
	cbLoadScreenShot.bChecked=Class'BDBMapVote'.Default.bLoadScreenShot;
	txtMessage = UWindowEditControl(CreateControl(Class'UWindowEditControl',RightSectionStart - 75 - MapListwidth,LowSectionStart + 45,2.0 * MapListwidth + 150,20.0));
	txtMessage.SetNumericOnly(False);
	txtMessage.SetHistory(True);
	txtMessage.SetMaxLength(150);

 	//Search module
	XL = 293;
	btnNext=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',WinWidth - XL,334,20,20));
	btnNext.DownSound=Sound'Botpack.Click';
	btnNext.bAlwaysOnTop = true;
	btnNext.Text=">";
	btnNext.bDisabled=False;	
	
	XL += 20;
	btnPrev=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',WinWidth - XL,334,20,20));
	btnPrev.DownSound=Sound'Botpack.Click';
	btnPrev.bAlwaysOnTop = true;
	btnPrev.Text="<";
	btnPrev.bDisabled=False;	
	
	lbSearchStatus = UMenuLabelControl(CreateControl(Class'UMenuLabelControl',30.00 + 2 * MapListwidth,354.00,PlayerListwidth,-168.00 + ListHeight));
	lbSearchStatus.bAlwaysOnTop = true;
	WhiteColor.R=255;
	WhiteColor.G=255;
	WhiteColor.B=255;
	lbSearchStatus.SetText("");
	lbSearchStatus.SetFont(F_Normal);
	lbSearchStatus.SetTextColor(TextColor);
	lbSearchStatus.Align=TA_Center;

	XL += 80;
	txtSearch=MapVoteEditControl(CreateControl(Class'MapVoteEditControl',WinWidth - XL,334,80,20));
	txtSearch.bAlwaysOnTop = true;
	txtSearch.SetNumericOnly(False);
	txtSearch.SetHistory(True);
	txtSearch.SetMaxLength(150);
	txtSearch.Align=TA_Left;
	
    //Focus txtMessage
    //Self.ActiveWindow = txtMessage;
    //Set Tabs for txtMessage and txtSearch
    //txtMessage.TabNext = txtSearch;
    //txtMessage.TabPrev = txtSearch;
    //txtSearch.TabNext = txtMessage;
    //txtSearch.TabPrev = txtMessage;

	SendButton = UWindowSmallButton(CreateControl(Class'UWindowSmallButton',RightSectionStart + 2 * MapListwidth - 30,LowSectionStart + 45,40.0,20.0));
	SendButton.DownSound=Sound'Botpack.Click';
	SendButton.Text="Send";
	SendButton.bDisabled=False;
	CloseButton = UWindowSmallButton(CreateControl(Class'UWindowSmallButton',RightSectionStart,LowSectionStart + 75,2.0 * MapListwidth + 10,20.0));
	CloseButton.DownSound=Sound'WindowClose';
	CloseButton.Text="Close";
	CloseButton.bDisabled=False;
}

function NextSearchItem(optional bool bPrev)
{
  if(SelectedSearchIndex > 0)
  {
    if(bPrev)
    {
      SelectedSearchIndex--;
      if(SelectedSearchIndex < 1) SelectedSearchIndex = TotalSearchItems;    
    }
    else
    {       
      SelectedSearchIndex++;    
      if(SelectedSearchIndex > TotalSearchItems) SelectedSearchIndex = 1; 
    }    
    
    SelectMapFromSearch(SelectedSearchIndex);                   
    //lbSelectedMap.SetText("Selected Map:" $ CurrentMapName);
    lbSearchStatus.SetText(SelectedSearchIndex$"/"$TotalSearchItems);
  }
  //else
    //lbSelectedMap.SetText("");
  
  if(len(txtSearch.GetValue()) >= 3) 
    lbSearchStatus.SetText(SelectedSearchIndex$"/"$TotalSearchItems);
  else
    lbSearchStatus.SetText("");
}


function ClearSearch()
{
   for(TotalSearchItems = 1; TotalSearchItems < ArrayCount(SearchList) && SearchList[TotalSearchItems].Item != None; TotalSearchItems++ )
   {
     SearchList[TotalSearchItems].Item = None;
     SearchList[TotalSearchItems].Column = -1;
   }
   
   TotalSearchItems = 0;
}


function FindMap(string SearchText)
{
   local UMenuMapVoteList MapItem;
   local int i;  

   //Clear first.
   ClearSearch();
   
   for(i = 0; i < ArrayCount(MapListBox); i++)
   {
     for(MapItem=UMenuMapVoteList(MapListBox[i].Items); MapItem != None; MapItem=UMenuMapVoteList(MapItem.Next) )
     {
        if(InStr( Caps(MapItem.MapName), Caps(SearchText) ) != -1 && TotalSearchItems < ArrayCount(SearchList))
        {
           SearchList[++TotalSearchItems].Item = MapItem;
           SearchList[TotalSearchItems].Column = i;
        }
     }
   }
   
   if(TotalSearchItems > 0)
    SelectMapFromSearch(1);
}


function SelectMapFromSearch(int Index)
{
  if(SearchList[Index].Item != None) 
   {
     MapListBox[SearchList[Index].Column].SetSelectedItem(SearchList[Index].Item);     
     CurrentMapName = SearchList[Index].Item.MapName;
   }    
}

function DeSelectAllOtherMapListBoxItems (MapVoteListBox selListBox, int listNum)
{
  local int i;
  
  for( i = 0; i < ArrayCount(MapListBox); i++)
  {
    if(listnum != i)
    {
      if(MapListBox[i].SelectedItem != None)
      {
        MapListBox[i].SelectedItem.bSelected = False;
        MapListBox[i].SelectedItem = None;
      }
    }
  }  
  
  if(listNum >= 0 && listnum < 4)  
    selListBox.MakeSelectedVisible();
}

function UWindowListBoxItem getSelectedItem()
{
  local int i;
  for( i = 0; i < ArrayCount(MapListBox); i++)
  {
    if(MapListBox[i].SelectedItem != None)
      return MapListBox[i].SelectedItem;
  }
  
}

function MaplistAction(MapVoteListBox xMapListBox,int ListNum)
{
    if ( CheckTimeSubmit() )
	{
		if ( ( Left(UMenuMapVoteList(xMapListBox.SelectedItem).MapName,3) != "[X]" || 
                GetPlayerOwner().PlayerReplicationInfo.bAdmin ) && UMenuMapVoteList(xMapListBox.SelectedItem).MapName != "")
            ExecCommand("MAP",UMenuMapVoteList(xMapListBox.SelectedItem).MapName);
	}
	
    SelectionTime=GetPlayerOwner().Level.TimeSeconds;
	DeSelectAllOtherMapListBoxItems(xMapListBox,ListNum);
}

//Prevent Spam
function bool CheckTimeSubmit()
{
    return (GetPlayerOwner().Level.TimeSeconds > LastVoteTime + 5); 
}

function ExecCommand(string CMD, string Params,optional bool bOverride)
{
    if(bOverride)
    {
        GetPlayerOwner().ConsoleCommand(CMD @ Params);
        return;
    }
    
    GetPlayerOwner().ConsoleCommand("MUTATE BDBMAPVOTE" @ CMD @ Params);
    LastVoteTime = GetPlayerOwner().Level.TimeSeconds;    
}

function Notify (UWindowDialogControl C, byte E)
{
	local int listNum;
	local int i;

	Super.Notify(C,E);
	switch (E)
	{
//-----------------------------------------------------------------------------------        
        case DE_Change:
            switch(C)
            {
            case txtSearch:
                //Search                    
                if(len(txtSearch.GetValue()) >= 3)
                { 
                    FindMap(txtSearch.GetValue());
                    SelectedSearchIndex = int(TotalSearchItems > 0);
                    lbSearchStatus.SetText(SelectedSearchIndex$"/"$TotalSearchItems);
                    //if(SelectedSearchIndex > 0)
                        //lbSelectedMap.SetText("Selected Map:" $ CurrentMapName);
                    //else
                        //lbSelectedMap.SetText("");
                }
                else
                {
                    ClearSearch();           
                    SelectedSearchIndex = 0;
                    //lbSelectedMap.SetText("");
                    lbSearchStatus.SetText("");
                }            
                break;
            }
            break;           

//-----------------------------------------------------------------------------------

		case DE_DoubleClick:		
            //DoubleClick for all Maplists
            for( i = 0; i < ArrayCount(MapListBox); i++)
            {
                if(MapListBox[i] == C)
                {
                    MapListAction(MapListBox[i],i);
                    return;
                }
            }
            
            switch (C)
            {			
                case lstMapStatus:
                    
                    listNum = getListNum(MapStatusListItem(lstMapStatus.SelectedItem).MapName);
                    DeSelectAllOtherMapListBoxItems(MapListBox[0],5);			
                    if(listNum > 0)
                        MapListBox[listNum - 1].SelectMap(MapStatusListItem(lstMapStatus.SelectedItem).MapName);
                
                    if ( CheckTimeSubmit() && MapStatusListItem(lstMapStatus.SelectedItem).MapName != "")
                        ExecCommand("MAP",MapStatusListItem(lstMapStatus.SelectedItem).MapName);
                        
                    SelectionTime=GetPlayerOwner().Level.TimeSeconds;                    
                    
                    break;
                
                case lstKickStatus:                    
                    
                    PlayerListBox.SelectPlayer(KickStatusListItem(lstKickStatus.SelectedItem).PlayerName);            
                    if ( CheckTimeSubmit() && PlayerVoteListItem(PlayerListBox.SelectedItem).PlayerName != "")
                        ExecCommand("KICK",PlayerVoteListItem(PlayerListBox.SelectedItem).PlayerName);
                        
                    break;
                                        
                case PlayerListBox:
                    
                    if ( CheckTimeSubmit() && PlayerVoteListItem(PlayerListBox.SelectedItem).PlayerName != "")
                        ExecCommand("KICK",PlayerVoteListItem(PlayerListBox.SelectedItem).PlayerName);
                        
                    break;

                default:
            }
            break;
            
//-----------------------------------------------------------------------------------

		case DE_Click:		
            //Click event for all Maplists
            for( i = 0; i < ArrayCount(MapListBox); i++)
            {
                if(MapListBox[i] == C)
                {
                    SelectionTime=GetPlayerOwner().Level.TimeSeconds;
                    DeSelectAllOtherMapListBoxItems(MapListBox[i],i);
                    return;
                }
            }
						
            switch (C)
            {
                case btnNext: NextSearchItem();      break;
                case btnPrev: NextSearchItem(true);  break;      
            
                case SendButton:
                
                    if ( txtMessage.GetValue() != "" )
                    {
                        ExecCommand("SAY",txtMessage.GetValue(),true);
                        txtMessage.SetValue("");
                    }
                    break;
                
                case VoteButton:
                
                    if ( CheckTimeSubmit() && getSelectedItem() != None )
                    {
                        if ( Left(UMenuMapVoteList(getSelectedItem()).MapName,3) != "[X]" || 
                            GetPlayerOwner().PlayerReplicationInfo.bAdmin )
                        {
                            if ( UMenuMapVoteList(getSelectedItem()).MapName != "" )
                                ExecCommand("MAP", UMenuMapVoteList(getSelectedItem()).MapName);
                        }
                    }
                    break;
                
                case CloseButton:
                
                    ParentWindow.ParentWindow.Close();
                    break;
                
                case lstMapStatus:
                
                    listNum=getListNum(MapStatusListItem(lstMapStatus.SelectedItem).MapName);
                    DeSelectAllOtherMapListBoxItems(MapListBox[0],5);
                    if(listNum > 0)
                        MapListBox[listNum - 1].SelectMap(MapStatusListItem(lstMapStatus.SelectedItem).MapName);
                                
                    SelectionTime = GetPlayerOwner().Level.TimeSeconds;
                    break;
                
                case KickVoteButton:
                    
                    if ( CheckTimeSubmit() && PlayerVoteListItem(PlayerListBox.SelectedItem).PlayerName != "")
                        ExecCommand("KICK", PlayerVoteListItem(PlayerListBox.SelectedItem).PlayerName);
                        
                    break;
                
                //case RandomButton:
                    
                    //if ( CheckTimeSubmit() )
                        //ExecCommand("VOTERANDOMMAP","");
                        
                    //break;
                
                case lstKickStatus:
                
                    PlayerListBox.SelectPlayer(KickStatusListItem(lstKickStatus.SelectedItem).PlayerName);
                    break;
                    
                default:
            }
            break;

//-----------------------------------------------------------------------------------

    case DE_EnterPressed:
        switch(C)
        {
            case txtSearch:
                NextSearchItem();
                break;
                
            case txtMessage:
                if ( txtMessage.GetValue() != "" )
                {
                    ExecCommand("SAY",txtMessage.GetValue(),true);
                    txtMessage.SetValue("");
                    txtMessage.FocusOtherWindow(SendButton);
                }
                break;        
        }				
     default:
	}
}

function int getListNum (string MapName)
{
  local int i;
  
  for(i = 0; i < ArrayCount(MapListBox); i++)
  {
    if( MapListBox[i].isMapInList(MapName) )
      return i + 1;
  }
}

function Tick (float DeltaTime)
{
	if ( (SelectionTime != 0) && (GetPlayerOwner().Level.TimeSeconds > SelectionTime + 1) )
	{
		if ( getSelectedItem() != None )
		{
			SetMap(UMenuMapVoteList(getSelectedItem()).MapName);
			SelectionTime=0.00;
		}
	}
	Super.Tick(DeltaTime);
}

function SetMap (string MapName)
{
	local int i;
	local int pos;
	local string Prefix;
	local string RealPreFix;
	local LevelSummary L;
	local string RealMapName;

	if (  !cbLoadScreenShot.bChecked )
	{
		return;
	}
	bMapAlreadySet=True;
	i=InStr(Caps(MapName),".UNR");
	if ( i != -1 )
	{
		MapName=Left(MapName,i);
	}
	RealMapName=GetRealMapname(MapName);
	Screenshot=Texture(DynamicLoadObject(RealMapName $ ".Screenshot",Class'Texture'));
	L=LevelSummary(DynamicLoadObject(RealMapName $ ".LevelSummary",Class'LevelSummary'));
	if ( Left(MapName,3) == "[X]" )
	{
		MapTitle="You can NOT";
		MapAuthor="vote for this map.";
		IdealPlayerCount="";
	} else {
		if ( L != None )
		{
			MapTitle=L.Title;
			MapAuthor=L.Author;
			IdealPlayerCount=L.IdealPlayerCount;
		} else {
			MapTitle="DownLoad";
			MapAuthor="Required";
			IdealPlayerCount="";
		}
	}
}

function string GetRealMapname (string VirtualMap)
{
	local string MapName;
	local string Dictionary;
	local string virt;
	local string Real;

	Dictionary="TDM;DM;LMS;DM;" $ PrefixDictionary;
	if ( Left(VirtualMap,3) ~= "[X]" )
	{
		VirtualMap=Mid(VirtualMap,3);
	}
	MapName=VirtualMap;
JL004A:
	if ( Dictionary != "" )
	{
		virt=Left(Dictionary,InStr(Dictionary,";"));
		Dictionary=Mid(Dictionary,InStr(Dictionary,";") + 1);
		Real=Left(Dictionary,InStr(Dictionary,";"));
		Dictionary=Mid(Dictionary,InStr(Dictionary,";") + 1);
		if ( (Left(VirtualMap,4) != "CTF-") && (Left(VirtualMap,Len(virt) + 1) ~= (virt $ "-")) )
		{
			MapName=Real $ Mid(VirtualMap,Len(virt));
			return MapName;
		}
		goto JL004A;
	}
	return MapName;
}

function Paint (Canvas C, float MouseX, float MouseY)
{
	local int i;
	local int P1;
	local int P2;
	local int pos;
	local string TempText;
	local string textline;
	local float X;
	local float Y;
	local float W;
	local float H;

	Super.Paint(C,MouseX,MouseY);
	C.DrawColor = class'MVULClientSettings'.Default.BackgroundColor;
	DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,Texture'BackgroundTexture');
	if (  !bMapAlreadySet && (LogoTexture != "") && (Screenshot == None) )
	{
		Screenshot=Texture(DynamicLoadObject(LogoTexture,Class'Texture'));
		bMapAlreadySet=True;
	}
	if ( Screenshot != None )
	{
		C.DrawColor.R=255;
		C.DrawColor.G=255;
		C.DrawColor.B=255;
		DrawStretchedTexture(C,30.00 + 2 * MapListwidth,27.00,PlayerListwidth,110.00,Screenshot);
	}
	if ( MapTitle != "" )
	{
		lblMaptxt1.SetText(MapTitle);
	} else {
		lblMaptxt1.SetText("");
	}
	if ( MapAuthor != "" )
	{
		lblMaptxt2.SetText(MapAuthor);
	} else {
		lblMaptxt2.SetText("");
	}
	if ( IdealPlayerCount != "" )
	{
		lblMaptxt3.SetText(IdealPlayerCount @ "Players");
	} else {
		lblMaptxt3.SetText("");
	}
}

function KeyDown (int Key, float X, float Y)
{
	ParentWindow.KeyDown(Key,X,Y);
}

function Close (optional bool bByParent)
{
	local int W;
	local int Mode;

	if ( Class'BDBMapVote'.Default.bLoadScreenShot != cbLoadScreenShot.bChecked )
	{
		Class'BDBMapVote'.Default.bLoadScreenShot=cbLoadScreenShot.bChecked;
		Class'BDBMapVote'.StaticSaveConfig();
	}
	Super.Close(bByParent);
}

defaultproperties
{
    RedColor=(R=255,G=0,B=0,A=0),
    PurpleColor=(R=128,G=0,B=128,A=0),
    LightBlueColor=(R=0,G=100,B=255,A=0),
    TurquoiseColor=(R=0,G=255,B=255,A=0),
    GreenColor=(R=0,G=255,B=0,A=0),
    OrangeColor=(R=255,G=120,B=0,A=0),
    YellowColor=(R=255,G=255,B=0,A=0),
    PinkColor=(R=255,G=0,B=255,A=0),
    WhiteColor=(R=255,G=255,B=255,A=0),
    DeepBlueColor=(R=0,G=0,B=255,A=0),
}
