//================================================================================
// MapVoteTabWindow.
//================================================================================
class MapVoteTabWindow extends UWindowDialogClientWindow;

var UMenuPageControl Pages;
var MapVoteClientWindow MapWindow;
var ConfigTabWindow ConfigWindow;
var AdminTabWindow AdminWindow;
var ServerInfoWindow InfoWindow;
var string PrevSelectedMap;
var string PrevSelectedPlayer;
var int MapCount;
var string InfoServerAddress;
var int InfoServerPort;
var string InfoFilePath;
var string ServerInfoFile;
var float Width,Height;

function Created ()
{
	local UWindowPageControlPage PageControl;
	local float WidthLimit;
/*
	Width=Root.WinWidth;
	Height=Root.WinHeight;
	WidthLimit=300;

	if(Root.GuiScale >= 2 && Height <= 1000)
	{
	  Height/=1.09;
	  WinHeight=Height;
	  WinWidth=Fclamp(Width,WidthLimit,1000);
	}
	else
	{
	  WinHeight=FClamp(Height,WidthLimit,726);
	  WinWidth=Fclamp(Width,WidthLimit,963);

	if(WinWidth + 100 >= Width)
	  WinWidth  /= 1.02;

	if(WinHeight + 100 >= Height)
	  WinHeight /= 1.02;
	}
*/
	WinLeft=(Root.WinWidth - WinWidth) / 2;
	WinTop=(Root.WinHeight - WinHeight) / 2;

	Pages=UMenuPageControl(CreateWindow(Class'MapVotePageControl',0.00,0.00,WinWidth,WinHeight));
	Pages.SetMultiLine(False);

	PageControl=Pages.AddPage("Maps/Kick",Class'MapVoteClientWindow');
	MapWindow=MapVoteClientWindow(PageControl.Page);

	PageControl=Pages.AddPage("Config",Class'ConfigTabWindow');
	ConfigWindow=ConfigTabWindow(PageControl.Page);
	
	PageControl=Pages.AddPage("Info",Class'ServerInfoWindow');
	InfoWindow=ServerInfoWindow(PageControl.Page);

	if ( GetPlayerOwner().PlayerReplicationInfo.bAdmin )
	{
		PageControl=Pages.AddPage("Admin",Class'AdminTabWindow');
		AdminWindow=AdminTabWindow(PageControl.Page);
	}
	Super.Created();
}

function AddMapName (int listNum, string MapName)
{
	local UMenuMapVoteList i;
	
	if(listNum >= 1 && listNum <= 4)
			i = UMenuMapVoteList(MapWindow.MapListBox[listNum - 1].Items.Append(Class'UMenuMapVoteList'));
	i.MapName = MapName;
}

function ClearList (int listNum)
{
	if(listNum >= 1 && listNum <= 4)
		MapWindow.MapListBox[listNum - 1].Items.Clear();
}

function AddPlayerName (string PlayerName, bool bHasVoted)
{
	local PlayerVoteListItem i;
	local UWindowList Item;
	local int j;

	Item=MapWindow.PlayerListBox.Items;
JL001D:
	if ( Item != None )
	{
		if ( PlayerVoteListItem(Item).PlayerName == PlayerName )
		{
			return;
		}
		Item=Item.Next;
		goto JL001D;
	}
	i=PlayerVoteListItem(MapWindow.PlayerListBox.Items.Append(Class'PlayerVoteListItem'));
	i.PlayerName=PlayerName;
	i.bHasVoted=bHasVoted;
}

function ClearPlayerList ()
{
	MapWindow.PlayerListBox.Items.Clear();
}

function RemovePlayerName (string PlayerID)
{
	local UWindowList Item;

	Item=MapWindow.PlayerListBox.Items;
JL001D:
	if ( Item != None )
	{
		if ( Mid(PlayerVoteListItem(Item).PlayerName,1,3) == PlayerID )
		{
			Item.Remove();
			return;
		}
		Item=Item.Next;
		goto JL001D;
	}
}

function UpdatePlayerVoted (string PlayerID)
{
	local UWindowList Item;

	Item=MapWindow.PlayerListBox.Items;
JL001D:
	if ( Item != None )
	{
		if ( Mid(PlayerVoteListItem(Item).PlayerName,1,3) == PlayerID )
		{
			PlayerVoteListItem(Item).bHasVoted=True;
			return;
		}
		Item=Item.Next;
		goto JL001D;
	}
}

function EnableKickWindow ()
{
	local UWindowPageControlPage PageControl;

	MapWindow.KickVoteButton.bDisabled=False;
	MapWindow.KickVoteButton.Text="Kick";
	MapWindow.PlayerListBox.bDisabled=False;
}

simulated function UpdateMapVoteResults (string Text, int i)
{
	local UWindowList Item;
	local string MapName;
	local int pos;
	local float C;

	if ( Text == "Clear" )
	{
		if ( MapWindow.lstMapStatus.SelectedItem != None )
		{
			PrevSelectedMap=MapStatusListItem(MapWindow.lstMapStatus.SelectedItem).MapName;
		}
		MapWindow.lstMapStatus.Items.Clear();
		return;
	}
	pos=InStr(Text,",");
	if ( pos > 0 )
	{
		MapName=Left(Text,pos);
		C=float(Mid(Text,pos + 1));
	}
	Item=MapWindow.lstMapStatus.Items;
JL00DC:
	if ( Item != None )
	{
		if ( MapStatusListItem(Item).MapName == MapName )
		{
			MapStatusListItem(Item).rank=i + 1;
			MapStatusListItem(Item).VoteCount=C;
			return;
		}
		Item=Item.Next;
		goto JL00DC;
	}
	Item=MapStatusListItem(MapWindow.lstMapStatus.Items.Append(Class'MapStatusListItem'));
	MapStatusListItem(Item).rank=i + 1;
	MapStatusListItem(Item).MapName=MapName;
	MapStatusListItem(Item).VoteCount=C;
	if ( PrevSelectedMap == MapName )
	{
		MapWindow.lstMapStatus.SelectMap(PrevSelectedMap);
	}
}

simulated function UpdateKickVoteResults (string Text, int i)
{
	local UWindowList Item;
	local string PlayerName;
	local int C;
	local int pos;

	if ( Text == "" )
	{
		return;
	}
	if ( Text == "Clear" )
	{
		if ( MapWindow.lstKickStatus.SelectedItem != None )
		{
			PrevSelectedPlayer=KickStatusListItem(MapWindow.lstKickStatus.SelectedItem).PlayerName;
		}
		MapWindow.lstKickStatus.Items.Clear();
		return;
	}
	pos=InStr(Text,",");
	if ( pos > 0 )
	{
		PlayerName=Left(Text,pos);
		C=int(Mid(Text,pos + 1));
	}
	if ( MapWindow.lstKickStatus.Items != None )
	{
		Item=MapWindow.lstKickStatus.Items;
JL0107:
		if ( Item != None )
		{
			if ( KickStatusListItem(Item).PlayerName == PlayerName )
			{
				KickStatusListItem(Item).VoteCount=C;
				return;
			}
			Item=Item.Next;
			goto JL0107;
		}
	}
	Item=KickStatusListItem(MapWindow.lstKickStatus.Items.Append(Class'KickStatusListItem'));
	KickStatusListItem(Item).PlayerName=PlayerName;
	KickStatusListItem(Item).VoteCount=C;
	if ( (PrevSelectedPlayer != "") && (PrevSelectedPlayer == PlayerName) )
	{
		MapWindow.lstKickStatus.SelectPlayer(PrevSelectedPlayer);
	}
}

defaultproperties
{
}
